#ifndef Q7B_CONTROLS_H
#define Q7B_CONTROLS_H

#include <QPushButton>
#include <QCheckBox>
#include <QComboBox>
#include <QListWidget>
#include <QProgressBar>
#include <QLabel>
#include <QLineEdit>
#include <QTreeWidget>




#include <QPainter>
#include <QBrush>
#include <QPalette>


/*
TODO

ToolButton
RichtTextBox
HtmlView
DateBox
TimeBox
DateTimeBox
Slider
ScrollBar
SpinBox
MovieBox
Sound
WebView
ResizeBox
CommandLinkButton
SvgBox
ToolBarView
FormsView

*/

class CommandButton : public QPushButton
{
    Q_OBJECT

public:
    CommandButton() : QPushButton(){ setText("CommandButton"); }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class TreeView : public QTreeWidget
{
    Q_OBJECT

public:
    TreeView() : QTreeWidget(){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class ListView : public QTreeWidget
{
    Q_OBJECT

public:
    ListView() : QTreeWidget(){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class ImageButton : public QLabel
{
    Q_OBJECT

public:
    ImageButton(const QString & text, QWidget * parent = 0, Qt::WindowFlags f = 0) : QLabel(text, parent, f){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class Box : public QLabel
{
    Q_OBJECT

public:
    Box() : QLabel("Box"){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class FormView : public QLabel
{
    Q_OBJECT

public:
    FormView() : QLabel("FormView"){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};
/*
class Line : public QLabel
{
    Q_OBJECT

public:
    Line(const QString & text) : QLabel(text){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};*/

class Label : public QLabel
{
    Q_OBJECT

public:
    Label(const QString & text, QWidget * parent = 0, Qt::WindowFlags f = 0) : QLabel(text, parent, f){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class ProgressBar : public QProgressBar
{
    Q_OBJECT

public:
    ProgressBar() : QProgressBar(){  }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};




class TextBox : public QLineEdit
{
    Q_OBJECT

public:
    TextBox(const QString & contents, QWidget * parent = 0) : QLineEdit(contents, parent){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class ListBox : public QListWidget
{
    Q_OBJECT

public:
    ListBox() : QListWidget(){ }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class CheckBox : public QCheckBox
{
    Q_OBJECT

public:
    CheckBox(const QString & text, QWidget * parent = 0) : QCheckBox(text, parent){  }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class ComboBox : public QComboBox
{
    Q_OBJECT

public:
    ComboBox() : QComboBox(){ addItem("ComboBox"); }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};

class ImageBox : public QPushButton
{
    Q_OBJECT

public:
    ImageBox() : QPushButton(){ setText("ImageBox"); }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
        QPixmap pixmap;

        QPainter pixPaint(&pixmap);
        QBrush brush2( Qt::blue);
        pixPaint.setBrush(brush2);
        pixPaint.drawLine(1, 1, 11, 11);

        QPalette p = palette();
        QBrush b(pixmap);
        p.setBrush(QPalette::Window, b);
        setPalette(p);

    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};


class Timer : public QPushButton
{
    Q_OBJECT

public:
    Timer() : QPushButton(){ setText("Timer"); }

    QString value(){ return Value; }
    void setValue(QString s){
        Value = s;
    }

 Q_PROPERTY(QString Value READ value WRITE setValue)
private:
    QString Value;
};


#endif // Q7B_CONTROLS_H
